;	 chunkyfile_demo.pb
;	 Version 0.2 [2010/10/08]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awchunkyfile.pbi"

OpenConsole()

PrintN("AWPB-Tools ChunkyFile-Demo")
PrintN("")

Define *cf.AWPB_ChunkyFile

Print("Allocating ChunkyFile ... ")
*cf = AWPB_CreateChunkyFileObj()
If *cf
  PrintN("success")
  Print("Creating file ... ")
  If *cf\Open("chunkyfile.cf", "XXXX", #AWPB_FILE_MODE_WRITE)
    PrintN("success")
    Print("Creating Chunk ... ")
    If *cf\OpenChunk("CF#1")
      PrintN("success")
      *cf\WriteByte($AB)
      *cf\WriteWord($ABBA)
      *cf\WriteLong($ABCDEF12)
      *cf\WriteQuad($ABCDEF1234567890)
      *cf\WriteDouble(1234.5678)
      *cf\WriteFloat(8765.4321)
      *cf\CloseChunk()
    Else
      PrintN("failed")
    EndIf
    Print("Creating Chunk ... ")
    If *cf\OpenChunk("CF#2")
      PrintN("success")
      *cf\WriteString("1. Ein unkomprimierter UNICODE Teststring. ", #PB_Unicode, #AWPB_ZIP_COMP_NONE)
      *cf\WriteString("2. Ein unkomprimierter UTF8 Teststring. ", #PB_UTF8, #AWPB_ZIP_COMP_NONE)
      *cf\WriteString("3. Ein unkomprimierter ASCII Teststring. ", #PB_Ascii, #AWPB_ZIP_COMP_NONE)
      *cf\CloseChunk()
    Else
      PrintN("failed")
    EndIf
    Print("Creating Chunk ... ")
    If *cf\OpenChunk("CF#2")
      PrintN("success")
      *cf\WriteString("1. Ein komprimierter UNICODE Teststring. Ein komprimierter UNICODE Teststring. ", #PB_Unicode, #AWPB_ZIP_COMP_MAX)
      *cf\WriteString("2. Ein komprimierter UTF8 Teststring. Ein komprimierter UTF8 Teststring. ", #PB_UTF8, #AWPB_ZIP_COMP_MAX)
      *cf\WriteString("3. Ein komprimierter ASCII Teststring. Ein komprimierter ASCII Teststring. ", #PB_Ascii, #AWPB_ZIP_COMP_MAX)
      *cf\CloseChunk()
    Else
      PrintN("failed")
    EndIf
    *cf\Close()
    
PrintN("Press return to continue demo")
Input()

    Print("Opening File ... ")
    If *cf\Open("chunkyfile.cf", "YYYY", #AWPB_FILE_MODE_READ)
      PrintN("success") ; sollte nie vorkommen, da der Header falsch ist
      *cf\Close()
    Else
      PrintN("failed")
    EndIf
    
    Print("Opening File ... ")
    If *cf\Open("chunkyfile.cf", "XXXX", #AWPB_FILE_MODE_READ)
      PrintN("success")
      While *cf\NextChunk()
        PrintN("Found Chunk " + *cf\GetChunkHeader() + " Size: " + Str(*cf\GetChunkSize()))
        If *cf\CheckChunkIntegrity() 
          PrintN("CRC passed")
        Else
          PrintN("CRC failed")
        EndIf
        If *cf\GetChunkHeader() = "CF#1"
          PrintN("Byte:   " + Hex(*cf\ReadByte(), #PB_Byte) + " should be AB")
          PrintN("Word:   " + Hex(*cf\ReadWord(), #PB_Word) + " should be ABBA")
          PrintN("Long:   " + Hex(*cf\ReadLong(), #PB_Long) + " should be ABCDEF12")
          PrintN("Quad:   " + Hex(*cf\ReadQuad(), #PB_Quad) + " should be ABCDEF1234567890")
          PrintN("Double: " + StrD(*cf\ReadDouble()) + " should be 1234.5678")
          PrintN("Float:  " + StrF(*cf\ReadFloat()) + " should be 8765.4321")
        ElseIf *cf\GetChunkHeader() = "CF#2"
          PrintN("Read String >" + *cf\ReadString() + "<")
          PrintN("Read String >" + *cf\ReadString() + "<")
          PrintN("Read String >" + *cf\ReadString() + "<")
        ElseIf *cf\GetChunkHeader() = "CF#3"
          PrintN("Read String >" + *cf\ReadString() + "<")
          PrintN("Read String >" + *cf\ReadString() + "<")
          PrintN("Read String >" + *cf\ReadString() + "<")
        EndIf
      Wend
      *cf\Close()
    Else
      PrintN("failed")
    EndIf
  Else
    PrintN("failed")
  EndIf
  *cf\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

