;    guilayout_demo4.pb
;    Version 0.3 [2012/05/20]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awguilayout.pbi"

Define win, gdg0, gdg1, gdg2, gdg3, gdg4, gdg5
Define *sizer.AWPB_GUILO_Sizer, s1.i, s2.i, s3.i
Define GadgetEx.AWPB_GUILO_Sizer_Gadget

win = OpenWindow(#PB_Any, 542, 122, 410, 410, "GUI-Layout-Demo", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
If IsWindow(win)
	*sizer = AWPB_CreateSizerObj(win)
	If *sizer
		gdg0 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "first Gadget - without borders, 20% height, 100% width");, #PB_Button_MultiLine)
		gdg1 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "second Gadget - with borders a 10 px, 20% height, 100% width");, #PB_Button_MultiLine)
		gdg2 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "third Gadget - without borders, 60% height, 50% width");, #PB_Button_MultiLine)
		gdg3 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "fourth Gadget - without borders, 30% height, 25% width");, #PB_Button_MultiLine)
		gdg5 = ButtonGadget(#PB_Any, 0, 0, 100, 10, "sixth Gadget - without borders, 60% height, 25% width");, #PB_Button_MultiLine)
		
		s1   = *sizer\AddSizer(#Null, #AWPB_GUILO_SIZER_VBOX, 100)
					 *sizer\AddGadget(s1, gdg0, 20)
					 With GadgetEx
					 	\ParentSizer = s1
						\GadgetID = gdg1
						\BorderLeft = 10
						\BorderRight = 10
						\BorderTop = 10
						\BorderBottom = 10
						\Size = 20
					 EndWith
					 *sizer\AddGadgetEx(@GadgetEx)
		s2   = *sizer\AddSizer(s1, #AWPB_GUILO_SIZER_HBOX, 60)
			   *sizer\AddGadget(s2, gdg2, 50)
		s3   = *sizer\AddSizer(s2, #AWPB_GUILO_SIZER_VBOX, 25)
			   *sizer\AddGadget(s3, gdg3, 50)
			   *sizer\AddSpacer(s3, 50)
			   *sizer\AddGadget(s2, gdg5, 25)
		
		*sizer\Finish()
		
		Repeat
			Select WaitWindowEvent()
				Case #PB_Event_SizeWindow
					*sizer\Resize()
				Case #PB_Event_CloseWindow
					Select EventWindow()
						Case win
							CloseWindow(win)
							win = 0
							Break
					EndSelect
			EndSelect
		ForEver
		
		*sizer\Destroy()
	Else
		MessageRequester("Fehler", "Konnte Sizer nicht erstellen")  
	EndIf
Else
	MessageRequester("Fehler", "Konnte Fenster nicht erstellen")  
EndIf

End


