;    guilayout_demo7.pb
;    Version 0.2 [2012/05/20]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awguilayout.pbi"

Define Win, PanelGdg, TreeGdg, ListGdg, EditGdg
Define SplitLeftCont, SplitRightCont, SplitGdg, Btn1, Btn2, Btn3, Btn4, Cal1, Frame1
Define Track1, IP1, String1, Option1a, Option1b, Option1c, Check1a, Check1b, Check1c, Check1d
Define tmp1, tmp2, tmp3, tmp4, tmp5
Define *MainSizer.AWPB_GUILO_Sizer, *PanelTab1Sizer.AWPB_GUILO_Sizer, *PanelTab2Sizer.AWPB_GUILO_Sizer, *PanelTab3Sizer.AWPB_GUILO_Sizer
Define *SplitLeftSizer.AWPB_GUILO_Sizer, *SplitRightSizer.AWPB_GUILO_Sizer
Define *SizerList.AWPB_GUILO_SizerList

; If LoadFont(1, "Arial", 20)
;   SetGadgetFont(#PB_Default, FontID(1))
; EndIf
     
Win = OpenWindow(#PB_Any, 0, 0, 500, 350, "GUI-Layout-Demo 7", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
If IsWindow(Win)
	PanelGdg = PanelGadget(#PB_Any, 0, 0, 1, 1)
		AddGadgetItem(PanelGdg, -1, "Tab 1")
			SplitLeftCont = ContainerGadget(#PB_Any, 0, 0, 1, 1, #PB_Container_Single)
				TreeGdg = TreeGadget(#PB_Any, 0, 0, 1, 1)
			CloseGadgetList()
			SplitRightCont = ContainerGadget(#PB_Any, 0, 0, 1, 1, #PB_Container_Single)
				ListGdg = ListViewGadget(#PB_Any, 0, 0, 1, 1)
				EditGdg = EditorGadget(#PB_Any, 0, 0, 1, 1)
			CloseGadgetList()
			SplitGdg = SplitterGadget(#PB_Any, 0, 0, 1, 1, SplitLeftCont, SplitRightCont, #PB_Splitter_Separator|#PB_Splitter_Vertical)
		AddGadgetItem(PanelGdg, -1, "Tab 2")
			Frame1 = FrameGadget(#PB_Any, 0, 0, 200, 1, "Commands", #PB_Frame_Double)
			Btn1 = ButtonGadget(#PB_Any, 0, 0, 1, 1, "Button 1")
			Btn2 = ButtonGadget(#PB_Any, 0, 0, 1, 1, "Button 2")
			Btn3 = ButtonGadget(#PB_Any, 0, 0, 1, 1, "Button 3")
			Btn4 = ButtonGadget(#PB_Any, 0, 0, 1, 1, "Button 4")
			Cal1 = CalendarGadget(#PB_Any, 0, 0, 1, 1)
		AddGadgetItem(PanelGdg, -1, "Tab 3")
			Track1 = TrackBarGadget(#PB_Any, 0, 0, 1, 1, 0, 100)
			IP1 = IPAddressGadget(#PB_Any, 0, 0, 1, 1)
			String1 = StringGadget(#PB_Any, 0, 0, 1, 1, "Test Text")
			Option1a = OptionGadget(#PB_Any, 0, 0, 1, 1, "Option 1")
			Option1b = OptionGadget(#PB_Any, 0, 0, 1, 1, "Option 2")
			Option1c = OptionGadget(#PB_Any, 0, 0, 1, 1, "Option 3")
			Check1a = CheckBoxGadget(#PB_Any, 0, 0, 1, 1, "Checkbox 1")
			Check1b = CheckBoxGadget(#PB_Any, 0, 0, 1, 1, "Checkbox 2")
			Check1c = CheckBoxGadget(#PB_Any, 0, 0, 1, 1, "Checkbox 3")
			Check1d = CheckBoxGadget(#PB_Any, 0, 0, 1, 1, "Checkbox 4")
	CloseGadgetList()
	
	*SizerList = AWPB_CreateSizerListObj()
	If *SizerList
		*MainSizer = *SizerList\AllocateSizer(Win)
		*PanelTab1Sizer  = *SizerList\AllocateSizer(PanelGdg, *MainSizer)
		*PanelTab2Sizer  = *SizerList\AllocateSizer(PanelGdg, *MainSizer)
		*PanelTab3Sizer  = *SizerList\AllocateSizer(PanelGdg, *MainSizer)
		*SplitLeftSizer  = *SizerList\AllocateSizer(SplitLeftCont, *PanelTab1Sizer)
		*SplitRightSizer = *SizerList\AllocateSizer(SplitRightCont, *PanelTab1Sizer)	
		If *MainSizer And *SplitLeftSizer And *SplitRightSizer And *PanelTab1Sizer And *PanelTab2Sizer And *PanelTab3Sizer
			*MainSizer\AddGadget(#Null, PanelGdg, 100)
			*PanelTab1Sizer\AddGadget(#Null, SplitGdg, 100)
			*SplitLeftSizer\AddGadget(#Null, TreeGdg, 100)
			tmp1 = *SplitRightSizer\AddSizer(#Null, #AWPB_GUILO_SIZER_VBOX, 100)
						*SplitRightSizer\AddGadget(tmp1, ListGdg, 50)
						*SplitRightSizer\AddGadget(tmp1, EditGdg, 50)
			tmp1 = *PanelTab2Sizer\AddSizer(#Null, #AWPB_GUILO_SIZER_HBOX, 100)
			tmp2 = *PanelTab2Sizer\AddFramedSizer(tmp1, Frame1, #AWPB_GUILO_SIZER_VBOX, 30)			
						*PanelTab2Sizer\AddGadget(tmp2, Btn1, 15)
						*PanelTab2Sizer\AddGadget(tmp2, Btn2, 15)
						*PanelTab2Sizer\AddSpacer(tmp2, 20)
						*PanelTab2Sizer\AddGadget(tmp2, Btn3, 15)
						*PanelTab2Sizer\AddSpacer(tmp2, 20)
						*PanelTab2Sizer\AddGadget(tmp2, Btn4, 15)
						*PanelTab2Sizer\AddGadget(tmp1, Cal1, 70)
			tmp1 = *PanelTab3Sizer\AddSizer(#Null, #AWPB_GUILO_SIZER_VBOX, 100)
						*PanelTab3Sizer\AddGadget(tmp1, Track1, 10)			
			tmp2 = *PanelTab3Sizer\AddSizer(tmp1, #AWPB_GUILO_SIZER_HBOX, 10)
						*PanelTab3Sizer\AddGadget(tmp2, IP1, 30)			
						*PanelTab3Sizer\AddGadget(tmp2, String1, 70)			
			tmp3 = *PanelTab3Sizer\AddSizer(tmp1, #AWPB_GUILO_SIZER_HBOX, 80)
			tmp4 = *PanelTab3Sizer\AddSizer(tmp3, #AWPB_GUILO_SIZER_VBOX, 50)
						*PanelTab3Sizer\AddGadget(tmp4, Option1a, 10)			
						*PanelTab3Sizer\AddGadget(tmp4, Option1b, 10)			
						*PanelTab3Sizer\AddGadget(tmp4, Option1c, 10)			
						*PanelTab3Sizer\AddSpacer(tmp4, 70)			
			tmp5 = *PanelTab3Sizer\AddSizer(tmp3, #AWPB_GUILO_SIZER_VBOX, 50)
						*PanelTab3Sizer\AddGadget(tmp5, Check1a, 10)			
						*PanelTab3Sizer\AddGadget(tmp5, Check1b, 10)			
						*PanelTab3Sizer\AddGadget(tmp5, Check1c, 10)			
						*PanelTab3Sizer\AddGadget(tmp5, Check1d, 10)			
						*PanelTab3Sizer\AddSpacer(tmp5, 60)			
			*SizerList\Finish()

	    Repeat
	      Select WaitWindowEvent()
				  Case #PB_Event_Gadget
				    Select EventGadget()
				    	Case SplitGdg
				    		*SizerList\Resize()
	    			EndSelect        
	    		Case #PB_Event_SizeWindow, #PB_Event_MaximizeWindow, #PB_Event_RestoreWindow 
		    		*SizerList\Resize()
	
	        Case #PB_Event_CloseWindow
	          Select EventWindow()
	            Case win
	              CloseWindow(win)
	              win = 0
	              Break
	          EndSelect
	      EndSelect
	    ForEver
	  Else
	    MessageRequester("Fehler", "Konnte Sizer nicht erstellen") 
	  EndIf
 		*SizerList\Destroy()
  Else
    MessageRequester("Fehler", "Konnte SizerList nicht erstellen") 
  EndIf	  
Else
  MessageRequester("Fehler", "Konnte Fenster nicht erstellen") 
EndIf

End

