;	 plainmail_demo.pb
;	 Version 0.2 [2010/10/03]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

OpenConsole()

PrintN("AWPB-Tools MailEncoder-Demo")
PrintN("")

Define *msg.AWPB_Message

Print("Allocating Message ... ")
*msg = AWPB_CreateMessageObj()
If *msg
  PrintN("success")
  Print("Building Message ... ")
  *msg\SetHeaderField(#AWPB_HDR_FROM, "ABSENDERADRESSE")
  *msg\SetHeaderField(#AWPB_HDR_TO, "EMPFNGERADRESSE")
  *msg\SetHeaderField(#AWPB_HDR_SUBJECT, "Der Betreff der Mail")
  *msg\SetDateNow()
  *msg\SetBodyText("Dies ist der Mailtext mit den Umlauten  und !", #AWPB_MSG_TYPE_PLAIN)
  
  If *msg\Encode()
    PrintN("done")
    PrintN("Saving mail ... ")
    If *msg\SaveEML("plainmail.eml")
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
    PrintN("Saving compressed binary mail ... ")
    If *msg\Save("plainmail_comp.bin", #AWPB_ZIP_COMP_MAX)
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
    PrintN("Saving uncompressed binary mail ... ")
    If *msg\Save("plainmail.bin", #AWPB_ZIP_COMP_STORE)
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
  Else
    PrintN("failed")
  EndIf  
  *msg\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

