; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** pop3_demo.pb         **
; ** V0.1 (2010/08/23)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

EnableExplicit

#Enable_OpenSSL = 1

; Ruft die erste Mail des angegebenen Acounts ab und zeigt Infos darber an.

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awpop3.pbi"
XIncludeFile "awmessage.pbi"

Define *pop.AWPB_POP3Client, *msg.AWPB_Message, file.s, err.i, cnt.i

InitNetwork()     ;- fr pop3 ntig
OpenConsole()

PrintN("AWPB-Tools POP3-Demo")
PrintN("")
If AWPB_SSL_InitSSLInterface()
	PrintN("SSL ready")
Else
	PrintN("SSL failed")
EndIf

Print("Allocating POP3-Client ... ")
*pop = AWPB_CreatePOP3ClientObj()
If *pop
  PrintN("success")
  *pop\SetServer("POP3 HOST", 110)    ;- Set  Mailserver und Port eintragen
  *pop\SetLogin("POP3 LOGIN", "POP3 PASSWORD")    ;- Set  Login und Passwort eintragen
  Print("Connecting ... ")
  err = *pop\Connect(#AWPB_POP3_CONN_AUTOTLS)
  If err = #AWPB_POP3_ERR_NONE
    PrintN("done")
    Print("Getting Message-Count ... ")
    cnt = *pop\GetMailCount()
    If cnt >= 0
      PrintN("success")
      PrintN("There are " + Str(cnt) + " mails on the server.")
      If cnt > 0
        Print("Retrieving mail 1 ... ")
        *msg = *pop\GetMail(1)
        If *msg
          PrintN("success")
          Print("Saving EML-Mail ... ")
          If *msg\SaveEML("pop3message1.eml")
            PrintN("Mail saved")
          Else
            PrintN("mail not saved")
          EndIf
          Print("Decoding Mail ... ")
          If *msg\Decode()
            PrintN("success")
            PrintN("Subject:         " + *msg\GetHeaderField(#AWPB_HDR_SUBJECT))
            PrintN("From:            " + *msg\GetHeaderField(#AWPB_HDR_FROM))
            PrintN("Date:            " + *msg\GetHeaderField(#AWPB_HDR_DATE))
            PrintN("To:              " + *msg\GetHeaderField(#AWPB_HDR_TO))
            PrintN("CC:              " + *msg\GetHeaderField(#AWPB_HDR_CC))
            PrintN("Size HTML-Part:  " + Str(Len(*msg\GetHTML())))
            PrintN("Size Plain-Part: " + Str(Len(*msg\GetPlain())))
            PrintN("Mailsize:        " + Str(*msg\GetSize()))
          Else
            PrintN("failed")
          EndIf
          *msg\Destroy()
        Else
          PrintN("failed")
        EndIf
      Else
        PrintN("No mails to test retrieving.")
      EndIf
    Else
      Select err
        Case #AWPB_POP3_ERR_FAIL:   PrintN("failed - general failure")
        Default:                    PrintN("failed - unknown error")
      EndSelect
      PrintN("Server replied: " + *pop\GetServerResult())
    EndIf
    Print("Disconnecting ... ")
    If *pop\DisConnect() = #AWPB_POP3_ERR_NONE
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
  Else
    Select err
      Case #AWPB_POP3_ERR_FAIL:   PrintN("failed - general failure")
      Case #AWPB_POP3_ERR_LOGIN:  PrintN("failed - login failed")
      Case #AWPB_POP3_ERR_USER:   PrintN("failed - username incorrect")
      Case #AWPB_POP3_ERR_PASS:   PrintN("failed - password incorrect")
      Default:                    PrintN("failed - unknown error")
    EndSelect
    PrintN("Server replied: " + *pop\GetServerResult())
  EndIf
  *pop\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

