; *****************************
; ** angelZware PB Tools Lib **
; ** ----------------------- **
; ** smtp_ssl_demo1.pb       **
; ** V0.2 (2013/07/23)       **
; ** by Ronny Krger         **
; *****************************
; ** Licence: LGPL V3        **
; *****************************

EnableExplicit

#Enable_OpenSSL = 1

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awsmtp.pbi"
XIncludeFile "awmessage.pbi"

Define *smtp.AWPB_SMTPClient, *msg.AWPB_Message, file.s, err.i

Debug ("SMTP"+Chr(10))
InitNetwork()     ;- fr smtp ntig
OpenConsole()

PrintN("AWPB-Tools SMTP-Demo")
PrintN("")
If AWPB_SSL_InitSSLInterface()
	PrintN("SSL ready")
Else
	PrintN("SSL failed")
EndIf

Print("Allocating Message ... ")
*msg = AWPB_CreateMessageObj()
If *msg
  PrintN("success")
  file = OpenFileRequester("Please choose file to load", "", "EML-Files (*.eml)|*.eml", 0)
  If file
    Print("Loading mail ... ")
    If *msg\LoadEML(file)
      PrintN("done")
      Print("Allocating SMTP-Client ... ")
      *smtp = AWPB_CreateSMTPClientObj()
      If *smtp
        PrintN("success")
        *smtp\SetServer("SMTP HOST", 25)    ;- Set  Mailserver und Port eintragen
        *smtp\SetLogin("SMTP LOGIN", "SMTP PASSWORT")    ;- Set  Login und Passwort eintragen
        Print("Connecting ... ")
        err = *smtp\Connect(#AWPB_SMTP_CONN_AUTOTLS)
        If err = #AWPB_SMTP_ERR_NONE
          PrintN("done")
          Print("Sending message ... ")
          err = *smtp\SendMail(*msg)
          If err = #AWPB_SMTP_ERR_NONE
            PrintN("success")
          Else
            Select err
              Case #AWPB_SMTP_ERR_FAIL:   PrintN("failed - general failure")
              Default:                    PrintN("failed - unknown error")
            EndSelect
            PrintN("Server replied: " + *smtp\GetServerResult())
          EndIf
          Print("Disconnecting ... ")
          If *smtp\DisConnect() = #AWPB_SMTP_ERR_NONE
            PrintN("done")
          Else
            PrintN("failed")
          EndIf
        Else
          Select err
            Case #AWPB_SMTP_ERR_FAIL:   PrintN("failed - general failure")
            Case #AWPB_SMTP_ERR_LOGIN:  PrintN("failed - login failed")
            Case #AWPB_SMTP_ERR_USER:   PrintN("failed - username incorrect")
            Case #AWPB_SMTP_ERR_PASS:   PrintN("failed - password incorrect")
            Default:                    PrintN("failed - unknown error")
          EndSelect
          PrintN("Server replied: " + *smtp\GetServerResult())
        EndIf
        *smtp\Destroy()
      Else
        PrintN("failed")
      EndIf
    Else
      PrintN("failed")
    EndIf
  EndIf
  *msg\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

