;	 webview_demo3.pb
;	 Version 0.1 [2011/01/21]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awwebview.pbi"

Define *webview.AWPB_WebView, Event

Procedure ResizeWebWindow()
  Shared *webview
  
  *webview\ResizeGadget(#PB_Ignore, #PB_Ignore, WindowWidth(0), WindowHeight(0) - 52)
  ResizeGadget(4, #PB_Ignore, #PB_Ignore, WindowWidth(0)-185, #PB_Ignore)
  ResizeGadget(5, WindowWidth(0)-25, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  ResizeGadget(6, #PB_Ignore, #PB_Ignore, WindowWidth(0), #PB_Ignore)
EndProcedure

If OpenWindow(0, 100, 200, 500, 300, "PureBasic MiniBrowser v1.0", #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget)

  CreateStatusBar(0, WindowID(0))
    AddStatusBarField(#PB_Ignore)
    StatusBarText(0, 0, "Welcome to the world's smallest Browser ! :)", 0)
      
  ButtonGadget(1,   0, 0, 50, 25, "Back")
  ButtonGadget(2,  50, 0, 50, 25, "Next")
  ButtonGadget(3, 100, 0, 50, 25, "Stop")

  StringGadget(4, 155, 5, 0, 20, "http://www.purebasic.com")
  
  ButtonGadget(5, 0, 0, 25, 25, "Go")
  
  FrameGadget(6, 0, 30, 0, 2, "", 2) ; Nice little separator
  
  *webview = AWPB_WebView(10, 0, 31, 0, 0, #PB_Container_Raised)
  If *webview
    *webview\LoadURI("http://www.purebasic.com")
  
    AddKeyboardShortcut(0, #PB_Shortcut_Return, 0)
  
    ResizeWebWindow()
  
    Repeat
      Event = WaitWindowEvent()
      
      Select Event
        Case #PB_Event_Gadget
        
          Select EventGadget()
            Case 1
              *webview\Back()
            Case 2
              *webview\Forward()

            Case 3
              *webview\Stop()
            
            Case 5
              *webview\LoadURI(GetGadgetText(4))
              
          EndSelect      
        
        Case #PB_Event_Menu ; We only have one shortcut
          *webview\LoadURI(GetGadgetText(4))
  
        Case #PB_Event_SizeWindow
          ResizeWebWindow()
        
      EndSelect
        
    Until Event = #PB_Event_CloseWindow
  EndIf
EndIf


