;    awmediainfo.pbi
;    Version 0.2 [2013/02/06]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;{ MediaInfo DLL/SO Imports
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfo_New()
Prototype   ____AWPB_MediaInfo_Proto_MediaInfo_Delete(*Handle)
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfoA_Open(*Handle, File.p-utf8)
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfoA_Get(*Handle, StreamKind.i, StreamNumber.i, Parameter.p-utf8, InfoKind.i, SearchKind.i)
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfoA_GetI(*Handle, StreamKind.i, StreamNumber.i, Parameter.i, InfoKind.i)
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfoA_Inform(*Handle, Reserved.i)
Prototype.i ____AWPB_MediaInfo_Proto_MediaInfoA_Option(*Handle, Option.p-utf8, Value.p-utf8)
Prototype   ____AWPB_MediaInfo_Proto_MediaInfoA_Close(*Handle)
;}
;{ LibTable
Structure ____AWPB_MediaInfo_Library
  LibHandle.i
  MediaInfo_New.____AWPB_MediaInfo_Proto_MediaInfo_New
  MediaInfo_Delete.____AWPB_MediaInfo_Proto_MediaInfo_Delete
  MediaInfoA_Open.____AWPB_MediaInfo_Proto_MediaInfoA_Open
  MediaInfoA_Inform.____AWPB_MediaInfo_Proto_MediaInfoA_Inform
  MediaInfoA_Option.____AWPB_MediaInfo_Proto_MediaInfoA_Option
  MediaInfoA_Close.____AWPB_MediaInfo_Proto_MediaInfoA_Close
  MediaInfoA_Get.____AWPB_MediaInfo_Proto_MediaInfoA_Get
  MediaInfoA_GetI.____AWPB_MediaInfo_Proto_MediaInfoA_GetI
EndStructure
;}
;{ Variables
Global ____AWPB_MediaInfo_LibMediaInfo.____AWPB_MediaInfo_Library
;}
;{ Constants
Enumeration
  #AWPB_MediaInfo_Stream_General
  #AWPB_MediaInfo_Stream_Video
  #AWPB_MediaInfo_Stream_Audio
  #AWPB_MediaInfo_Stream_Text
  #AWPB_MediaInfo_Stream_Chapters
  #AWPB_MediaInfo_Stream_Image
  #AWPB_MediaInfo_Stream_Menu
  #AWPB_MediaInfo_Stream_Max
EndEnumeration

Enumeration
  #AWPB_MediaInfo_Info_Name
  #AWPB_MediaInfo_Info_Text
  #AWPB_MediaInfo_Info_Measure
  #AWPB_MediaInfo_Info_Options
  #AWPB_MediaInfo_Info_NameText
  #AWPB_MediaInfo_Info_MeasureText
  #AWPB_MediaInfo_Info_Info
  #AWPB_MediaInfo_Info_HowTo
  #AWPB_MediaInfo_Info_Max
EndEnumeration

Enumeration
  #AWPB_MediaInfo_Option_ShowInInform
  #AWPB_MediaInfo_Option_Reserved
  #AWPB_MediaInfo_Option_ShowInSupported
  #AWPB_MediaInfo_Option_TypeOfValue
  #AWPB_MediaInfo_Option_Max
EndEnumeration
;}
;{ Support Macros
;** awpb_mediainfo_available
;* #True, wenn SSL zur Verfgung steht und initialisiert ist, sonst #False.
Macro AWPB_MediaInfo_Available
  (IsLibrary(____AWPB_MediaInfo_LibMediaInfo\LibHandle) And IsLibrary(____AWPB_MediaInfo_LibMediaInfo\LibHandle))
EndMacro
;}
;{ Library Initialization
Procedure.b AWPB_InitMediainfo(LibraryName.s = "")
	Protected res.b
	
	res = #False
  If LibraryName <> ""
    ____AWPB_MediaInfo_LibMediaInfo\LibHandle = OpenLibrary(#PB_Any, LibraryName)
  Else
    CompilerSelect #PB_Compiler_OS
      CompilerCase #PB_OS_Windows
        ____AWPB_MediaInfo_LibMediaInfo\LibHandle = OpenLibrary(#PB_Any, "mediainfo.dll")
      CompilerCase #PB_OS_Linux
        ____AWPB_MediaInfo_LibMediaInfo\LibHandle = OpenLibrary(#PB_Any, "./libmediainfo.so")
        If Not IsLibrary(____AWPB_MediaInfo_LibMediaInfo\LibHandle)
          ____AWPB_MediaInfo_LibMediaInfo\LibHandle = OpenLibrary(#PB_Any, "libmediainfo.so")
          If Not IsLibrary(____AWPB_MediaInfo_LibMediaInfo\LibHandle)
            ____AWPB_MediaInfo_LibMediaInfo\LibHandle = OpenLibrary(#PB_Any, "/usr/lib/libmediainfo.so")
          EndIf
        EndIf
    CompilerEndSelect
  EndIf
  
  If AWPB_MediaInfo_Available
    With ____AWPB_MediaInfo_LibMediaInfo
      \MediaInfo_Delete  = GetFunction(\LibHandle, "MediaInfo_Delete")
      \MediaInfo_New     = GetFunction(\LibHandle, "MediaInfo_New")
      \MediaInfoA_Close  = GetFunction(\LibHandle, "MediaInfoA_Close")
      \MediaInfoA_Inform = GetFunction(\LibHandle, "MediaInfoA_Inform")
      \MediaInfoA_Open   = GetFunction(\LibHandle, "MediaInfoA_Open")
      \MediaInfoA_Option = GetFunction(\LibHandle, "MediaInfoA_Option")
      \MediaInfoA_Get		 = GetFunction(\LibHandle, "MediaInfoA_Get")
      \MediaInfoA_GetI	 = GetFunction(\LibHandle, "MediaInfoA_GetI")
      
      If \MediaInfo_Delete <> #Null And \MediaInfo_New <> #Null And \MediaInfoA_Close <> #Null And \MediaInfoA_Inform <> #Null And \MediaInfoA_Open <> #Null And \MediaInfoA_Option <> #Null And \MediaInfoA_Get <> #Null And \MediaInfoA_GetI <> #Null 
      	res = #True
      Else
      	res = #False
      EndIf
      
    EndWith 
  EndIf

  ProcedureReturn res
EndProcedure
Procedure 	AWPB_FreeMediainfo()
  If AWPB_MediaInfo_Available
    CloseLibrary(____AWPB_MediaInfo_LibMediaInfo\LibHandle)
    ____AWPB_MediaInfo_LibMediaInfo\LibHandle = #Null
  EndIf
EndProcedure
;}
;{ MediaInfo Object
Interface AWPB_MediaInfo
  Destroy     				()
  Open.b      				(FileName.s)
  Close       				()
  Version.s   				()
  GetInfoBasePlain.s	()
  GetInfoFullPlain.s	()
  GetInfoBaseXML.s		()
  GetInfoFullXML.s		()
  GetInfoBaseHTML.s		()
  GetInfoFullHTML.s		()
  GetFileSize.i				()
  
  ; Low Level Access  
  MediaInfoA_Get.s		(StreamKind.i, StreamNumber.i, Parameter.s, InfoKind.i, SearchKind.i)
  MediaInfoA_GetI.s		(StreamKind.i, StreamNumber.i, Parameter.i, InfoKind.i)
  MediaInfoA_Inform.s	(Reserved.i)
  MediaInfoA_Option.s	(Option.s, Value.s)
EndInterface
Structure ____AWPB_MediaInfo
  *vt.____AWPB_MediaInfo_VT
  
  *Handle
  IsOpen.b
EndStructure
Procedure.i AWPB_CreateMediaInfoObj()
  Protected *this.____AWPB_MediaInfo
  
  If Not AWPB_MediaInfo_Available
    AWPB_InitMediainfo()
  EndIf
  
  If AWPB_MediaInfo_Available
    *this = AllocateMemory(SizeOf(____AWPB_MediaInfo))
    If *this
      InitializeStructure(*this, ____AWPB_MediaInfo)
      *this\vt     = ?____AWPB_MediaInfo_VT
      *this\Handle = ____AWPB_MediaInfo_LibMediaInfo\MediaInfo_New()
      *this\IsOpen = #False
      
      If *this\Handle
        ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "CodePage", "UTF-8")
        
        ProcedureReturn *this
      EndIf
      
      FreeMemory(*this)
    EndIf
  EndIf
  
  ProcedureReturn #Null
EndProcedure
Procedure   ____AWPB_MediaInfo_Close(*this.____AWPB_MediaInfo)
  If *this\IsOpen
    ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Close(*this\Handle)
    *this\IsOpen = #False
  EndIf
EndProcedure
Procedure   ____AWPB_MediaInfo_Destroy(*this.____AWPB_MediaInfo)
  ____AWPB_MediaInfo_Close(*this)
  ____AWPB_MediaInfo_LibMediaInfo\MediaInfo_Delete(*this\Handle)
EndProcedure
Procedure.b ____AWPB_MediaInfo_Open(*this.____AWPB_MediaInfo, FileName.s)
  ____AWPB_MediaInfo_Close(*this)
  
  If FileName <> ""
    If ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Open(*this\Handle, FileName)
      *this\IsOpen = #True
      ProcedureReturn #True
    EndIf
  EndIf
  
  ProcedureReturn #False
EndProcedure
Procedure.s ____AWPB_MediaInfo_Version(*this.____AWPB_MediaInfo)
  Protected res.s, *info
  
  res   = ""
  *info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Info_Version", "")
  If *info
    res = PeekS(*info, -1, #PB_UTF8)
  EndIf
  
  ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoBasePlain(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
	If *this\IsOpen
						____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "")
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoFullPlain(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
 	If *this\IsOpen
    				____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "1")
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoBaseXML(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
	If *this\IsOpen
					  ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Inform", "XML")
					  ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "")
 		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoFullXML(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
 	If *this\IsOpen
					  ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Inform", "XML")
    				____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "1")
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoBaseHTML(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
 	If *this\IsOpen
					  ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Inform", "HTML")
    				____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "")
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_MediaInfo_GetInfoFullHTML(*this.____AWPB_MediaInfo)
	Protected res.s, *info
	
	res = ""
 	If *this\IsOpen
					  ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Inform", "HTML")
    				____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, "Complete", "1")
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, 0)
    If *info
    	res = PeekS(*info, -1, #PB_UTF8)
    EndIf
  EndIf
	
	ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_MediaInfo_GetFileSize(*this.____AWPB_MediaInfo)
	Protected *info, sz.i
	
	sz = -1
 	If *this\IsOpen
 		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Get(*this\Handle, #AWPB_MediaInfo_Stream_General, 0, "FileSize", #AWPB_MediaInfo_Info_Text, #AWPB_MediaInfo_Info_Name)
    If *info
    	sz  = Val(PeekS(*info, -1, #PB_UTF8))
    EndIf
  EndIf
	
	ProcedureReturn sz
EndProcedure
Procedure.s ____AWPB_MediaInfo_MediaInfoA_Get(*this.____AWPB_MediaInfo, StreamKind.i, StreamNumber.i, Parameter.s, InfoKind.i, SearchKind.i)
	Protected *info, res.s
	
	res = ""
	If *this\IsOpen
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Get(*this\Handle, StreamKind, StreamNumber, Parameter, InfoKind, SearchKind)
		If *info
			res = PeekS(*info, -1, #PB_UTF8)
		EndIf
	EndIf
	
	ProcedureReturn res	
EndProcedure
Procedure.s ____AWPB_MediaInfo_MediaInfoA_GetI(*this.____AWPB_MediaInfo, StreamKind.i, StreamNumber.i, Parameter.i, InfoKind.i)
	Protected *info, res.s
	
	res = ""
	If *this\IsOpen
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_GetI(*this\Handle, StreamKind, StreamNumber, Parameter, InfoKind)
		If *info
			res = PeekS(*info, -1, #PB_UTF8)
		EndIf
	EndIf
	
	ProcedureReturn res	
EndProcedure
Procedure.s ____AWPB_MediaInfo_MediaInfoA_Option(*this.____AWPB_MediaInfo, Option.s, Value.s)
	Protected *info, res.s
	
	res = ""
	If *this\IsOpen
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Option(*this\Handle, Option, Value)
		If *info
			res = PeekS(*info, -1, #PB_UTF8)
		EndIf
	EndIf
	
	ProcedureReturn res	
EndProcedure
Procedure.s ____AWPB_MediaInfo_MediaInfoA_Inform(*this.____AWPB_MediaInfo, Reserved.i)
	Protected *info, res.s
	
	res = ""
	If *this\IsOpen
		*info = ____AWPB_MediaInfo_LibMediaInfo\MediaInfoA_Inform(*this\Handle, Reserved)
		If *info
			res = PeekS(*info, -1, #PB_UTF8)
		EndIf
	EndIf
	
	ProcedureReturn res	
EndProcedure

DataSection ;{ Virtual Function Table
____AWPB_MediaInfo_VT:
  Data.i @____AWPB_MediaInfo_Destroy()
  Data.i @____AWPB_MediaInfo_Open()
  Data.i @____AWPB_MediaInfo_Close()
  Data.i @____AWPB_MediaInfo_Version()
  Data.i @____AWPB_MediaInfo_GetInfoBasePlain()
  Data.i @____AWPB_MediaInfo_GetInfoFullPlain()
  Data.i @____AWPB_MediaInfo_GetInfoBaseXML()
  Data.i @____AWPB_MediaInfo_GetInfoFullXML()
  Data.i @____AWPB_MediaInfo_GetInfoBaseHTML()
  Data.i @____AWPB_MediaInfo_GetInfoFullHTML()
  Data.i @____AWPB_MediaInfo_GetFileSize()
  Data.i @____AWPB_MediaInfo_MediaInfoA_Get()
  Data.i @____AWPB_MediaInfo_MediaInfoA_GetI()
  Data.i @____AWPB_MediaInfo_MediaInfoA_Inform()
  Data.i @____AWPB_MediaInfo_MediaInfoA_Option()
  
EndDataSection ;}
;}
   
   
