;{   awopenssl.pbi
;    Version 0.4 [2013/08/14]
;    Copyright (C) 2012-2013 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.
;
;
; If using this interface in your project, please acknowledge following terms:
;
; License regarding OpenSSL
; =========================
;
;  LICENSE ISSUES
;  ==============
;
;  The OpenSSL toolkit stays under a dual license, i.e. both the conditions of
;  the OpenSSL License and the original SSLeay license apply to the toolkit.
;  See below for the actual license texts. Actually both licenses are BSD-style
;  Open Source licenses. In case of any license issues related to OpenSSL
;  please contact openssl-core@openssl.org.
;
;  OpenSSL License
;  ---------------
;
;/* ====================================================================
; * Copyright (c) 1998-2011 The OpenSSL Project.  All rights reserved.
; *
; * Redistribution and use in source and binary forms, with or without
; * modification, are permitted provided that the following conditions
; * are met:
; *
; * 1. Redistributions of source code must retain the above copyright
; *    notice, this list of conditions and the following disclaimer.
; *
; * 2. Redistributions in binary form must reproduce the above copyright
; *    notice, this list of conditions and the following disclaimer in
; *    the documentation and/or other materials provided with the
; *    distribution.
; *
; * 3. All advertising materials mentioning features or use of this
; *    software must display the following acknowledgment:
; *    "This product includes software developed by the OpenSSL Project
; *    for use in the OpenSSL Toolkit. (http://www.openssl.org/)"
; *
; * 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
; *    endorse or promote products derived from this software without
; *    prior written permission. For written permission, please contact
; *    openssl-core@openssl.org.
; *
; * 5. Products derived from this software may not be called "OpenSSL"
; *    nor may "OpenSSL" appear in their names without prior written
; *    permission of the OpenSSL Project.
; *
; * 6. Redistributions of any form whatsoever must retain the following
; *    acknowledgment:
; *    "This product includes software developed by the OpenSSL Project
; *    for use in the OpenSSL Toolkit (http://www.openssl.org/)"
; *
; * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
; * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
; * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenSSL PROJECT OR
; * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
; * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
; * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
; * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
; * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
; * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
; * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
; * OF THE POSSIBILITY OF SUCH DAMAGE.
; * ====================================================================
; *
; * This product includes cryptographic software written by Eric Young
; * (eay@cryptsoft.com).  This product includes software written by Tim
; * Hudson (tjh@cryptsoft.com).
; *
; */
;
; Original SSLeay License
; -----------------------
;
;/* Copyright (C) 1995-1998 Eric Young (eay@cryptsoft.com)
; * All rights reserved.
; *
; * This package is an SSL implementation written
; * by Eric Young (eay@cryptsoft.com).
; * The implementation was written so as to conform with Netscapes SSL.
; *
; * This library is free for commercial and non-commercial use as long as
; * the following conditions are aheared to.  The following conditions
; * apply to all code found in this distribution, be it the RC4, RSA,
; * lhash, DES, etc., code; not just the SSL code.  The SSL documentation
; * included with this distribution is covered by the same copyright terms
; * except that the holder is Tim Hudson (tjh@cryptsoft.com).
; *
; * Copyright remains Eric Young's, and as such any Copyright notices in
; * the code are not to be removed.
; * If this package is used in a product, Eric Young should be given attribution
; * as the author of the parts of the library used.
; * This can be in the form of a textual message at program startup or
; * in documentation (online or textual) provided with the package.
; *
; * Redistribution and use in source and binary forms, with or without
; * modification, are permitted provided that the following conditions
; * are met:
; * 1. Redistributions of source code must retain the copyright
; *    notice, this list of conditions and the following disclaimer.
; * 2. Redistributions in binary form must reproduce the above copyright
; *    notice, this list of conditions and the following disclaimer in the
; *    documentation and/or other materials provided with the distribution.
; * 3. All advertising materials mentioning features or use of this software
; *    must display the following acknowledgement:
; *    "This product includes cryptographic software written by
; *     Eric Young (eay@cryptsoft.com)"
; *    The word 'cryptographic' can be left out if the rouines from the library
; *    being used are not cryptographic related :-).
; * 4. If you include any Windows specific code (or a derivative thereof) from
; *    the apps directory (application code) you must include an acknowledgement:
; *    "This product includes software written by Tim Hudson (tjh@cryptsoft.com)"
; *
; * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
; * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
; * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
; * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
; * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
; * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
; * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
; * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
; * SUCH DAMAGE.
; *
; * The licence and distribution terms for any publically available version or
; * derivative of this code cannot be changed.  i.e. this code cannot simply be
; * copied and put under another distribution licence
; * [including the GNU Public Licence.]
; */
;
;
; Note: this is a reduced interface just to satisfy use with pop3/smtp
;}

;{ Constants
#SSL_ERROR_NONE             = 0
#SSL_ERROR_SSL              = 1
#SSL_ERROR_WANT_READ        = 2
#SSL_ERROR_WANT_WRITE       = 3
#SSL_ERROR_WANT_X509_LOOKUP = 4
#SSL_ERROR_SYSCALL          = 5 ; look at error stack/Return value/errno
#SSL_ERROR_ZERO_RETURN      = 6
#SSL_ERROR_WANT_CONNECT     = 7
#SSL_ERROR_WANT_ACCEPT      = 8
;}
;{ Prototypes
PrototypeC.l ____SSL_Proto_SSL_get_error(*s, ret_code.l)
PrototypeC.i ____SSL_Proto_SSL_library_init()
PrototypeC   ____SSL_Proto_SSL_load_error_strings()
PrototypeC.i ____SSL_Proto_SSL_CTX_new(*meth)
PrototypeC   ____SSL_Proto_SSL_CTX_free(*arg0)
PrototypeC.i ____SSL_Proto_SSL_set_fd(*s, fd.i)	;- lt C muesste fd.l sein ... hm
PrototypeC.i ____SSL_Proto_SSLv2_client_method()
PrototypeC.i ____SSL_Proto_SSLv3_client_method()
PrototypeC.i ____SSL_Proto_TLSv1_client_method()
PrototypeC.i ____SSL_Proto_SSLv23_client_method()
PrototypeC.i ____SSL_Proto_SSL_new(*ctx)
PrototypeC   ____SSL_Proto_SSL_free(*ssl)
PrototypeC.l ____SSL_Proto_SSL_connect(*ssl)
PrototypeC.l ____SSL_Proto_SSL_shutdown(*ssl)
PrototypeC.l ____SSL_Proto_SSL_read(*ssl, *buf, num.l)
PrototypeC.l ____SSL_Proto_SSL_peek(*ssl, *buf, num.l)
PrototypeC.l ____SSL_Proto_SSL_write(*ssl, *buf, num.l)
PrototypeC.l ____SSL_Proto_SSL_pending(*ssl)
PrototypeC.i ____SSL_Proto_SSL_get_version(*ssl) ; returns char*
;}
;{ Structures
Structure ____SSL_libssl_table
  LibHandle.i
  SSL_get_error.____SSL_Proto_SSL_get_error
  SSL_library_init.____SSL_Proto_SSL_library_init
  SSL_load_error_strings.____SSL_Proto_SSL_load_error_strings
  SSL_CTX_new.____SSL_Proto_SSL_CTX_new
  SSL_CTX_free.____SSL_Proto_SSL_CTX_free
  SSL_set_fd.____SSL_Proto_SSL_set_fd
  SSLv2_client_method.____SSL_Proto_SSLv2_client_method
  SSLv3_client_method.____SSL_Proto_SSLv3_client_method
  TLSv1_client_method.____SSL_Proto_TLSv1_client_method
  SSLv23_client_method.____SSL_Proto_SSLv23_client_method
  SSL_new.____SSL_Proto_SSL_new
  SSL_free.____SSL_Proto_SSL_free
  SSL_connect.____SSL_Proto_SSL_connect
  SSL_shutdown.____SSL_Proto_SSL_shutdown
  SSL_read.____SSL_Proto_SSL_read
  SSL_peek.____SSL_Proto_SSL_peek
  SSL_write.____SSL_Proto_SSL_write
  SSL_pending.____SSL_Proto_SSL_pending
  SSL_get_version.____SSL_Proto_SSL_get_version
EndStructure
;}
;{ Variables
Define ____SSL_LibSSL.____SSL_libssl_table
;}
;{ private Functions
Procedure   ____SSL_Free()
  Shared ____SSL_LibSSL

  If IsLibrary(____SSL_LibSSL\LibHandle) : CloseLibrary(____SSL_LibSSL\LibHandle) : EndIf

  ClearStructure(@____SSL_LibSSL, ____SSL_libssl_table)
EndProcedure
Procedure.i ____SSL_Init()
  Shared    ____SSL_LibSSL

  ClearStructure(@____SSL_LibSSL, ____SSL_libssl_table)

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      ____SSL_LibSSL\LibHandle = OpenLibrary(#PB_Any, "ssleay32.dll")
      If Not IsLibrary(____SSL_LibSSL\LibHandle)
        ____SSL_LibSSL\LibHandle = OpenLibrary(#PB_Any, "libssl32.dll")
      EndIf
    CompilerCase #PB_OS_Linux
      ____SSL_LibSSL\LibHandle = OpenLibrary(#PB_Any, "libssl.so")
      If Not IsLibrary(____SSL_LibSSL\LibHandle)
        ____SSL_LibSSL\LibHandle = OpenLibrary(#PB_Any, "./libssl.so")
        If Not IsLibrary(____SSL_LibSSL\LibHandle)
          ____SSL_LibSSL\LibHandle = OpenLibrary(#PB_Any, "/usr/lib/libssl.so")
          If Not IsLibrary(____SSL_LibSSL\LibHandle)
            ProcedureReturn #False
          EndIf
        EndIf
      EndIf
  CompilerEndSelect

  If IsLibrary(____SSL_LibSSL\LibHandle)
  	With ____SSL_LibSSL
      \SSL_get_error          = GetFunction(\LibHandle, "SSL_get_error")
      \SSL_library_init       = GetFunction(\LibHandle, "SSL_library_init")
      \SSL_load_error_strings = GetFunction(\LibHandle, "SSL_load_error_strings")
      \SSL_CTX_new            = GetFunction(\LibHandle, "SSL_CTX_new")
      \SSL_CTX_free           = GetFunction(\LibHandle, "SSL_CTX_free")
      \SSL_set_fd             = GetFunction(\LibHandle, "SSL_set_fd")
      \SSLv2_client_method    = GetFunction(\LibHandle, "SSLv2_client_method")
      \SSLv3_client_method    = GetFunction(\LibHandle, "SSLv3_client_method")
      \TLSv1_client_method    = GetFunction(\LibHandle, "TLSv1_client_method")
      \SSLv23_client_method   = GetFunction(\LibHandle, "SSLv23_client_method")
      \SSL_new                = GetFunction(\LibHandle, "SSL_new")
      \SSL_free               = GetFunction(\LibHandle, "SSL_free")
      \SSL_connect            = GetFunction(\LibHandle, "SSL_connect")
      \SSL_shutdown           = GetFunction(\LibHandle, "SSL_shutdown")
      \SSL_read               = GetFunction(\LibHandle, "SSL_read")
      \SSL_peek               = GetFunction(\LibHandle, "SSL_peek")
      \SSL_write              = GetFunction(\LibHandle, "SSL_write")
      \SSL_pending            = GetFunction(\LibHandle, "SSL_pending")
      \SSL_get_version        = GetFunction(\LibHandle, "SSL_get_version")

		If (\SSL_get_error <> #Null) And (\SSL_get_error <> #Null) And (\SSL_library_init <> #Null) And (\SSL_load_error_strings <> #Null) And (\SSL_CTX_new <> #Null) And (\SSL_CTX_free <> #Null) And (\SSL_set_fd <> #Null) And (\SSLv2_client_method <> #Null) And (\SSLv3_client_method <> #Null) And (\TLSv1_client_method <> #Null) And (\SSLv23_client_method <> #Null) And (\SSL_new <> #Null) And (\SSL_free <> #Null) And (\SSL_connect <> #Null) And (\SSL_shutdown <> #Null) And (\SSL_read <> #Null) And (\SSL_peek <> #Null) And (\SSL_write <> #Null) And (\SSL_pending <> #Null) And (\SSL_get_version <> #Null)
			ProcedureReturn #True
		EndIf
	EndWith
  EndIf

  ____SSL_Free()

  ProcedureReturn #False
EndProcedure
Procedure.i ____SSL_InitSSLInterface()
  Shared     ____SSL_LibSSL
  Protected result.i

  result = #False
  If ____SSL_Init()
    ____SSL_LibSSL\SSL_library_init()
    ____SSL_LibSSL\SSL_load_error_strings()
    result = #True
  EndIf

  ProcedureReturn result
EndProcedure
Procedure   ____SSL_DestroySSLInterface()
  Shared     ____SSL_LibSSL

  ____SSL_Free()
EndProcedure
;}
;{ public functions
Procedure   AWPB_SSL_Available()
	Shared ____SSL_LibSSL

	ProcedureReturn IsLibrary(____SSL_LibSSL\LibHandle)
EndProcedure
Procedure.i AWPB_SSL_InitSSLInterface()
  ProcedureReturn ____SSL_InitSSLInterface()
EndProcedure
Procedure   AWPB_SSL_DestroySSLInterface()
  ____SSL_DestroySSLInterface()
EndProcedure
Procedure.i SSL_CTX_new(*meth)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_CTX_new
  	ProcedureReturn ____SSL_LibSSL\SSL_CTX_new(*meth)
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure   SSL_CTX_free(*arg0)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_CTX_free
    ____SSL_LibSSL\SSL_CTX_free(*arg0)
  EndIf
EndProcedure
Procedure.i SSL_set_fd(*s, fd.i)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_set_fd
    ProcedureReturn ____SSL_LibSSL\SSL_set_fd(*s, fd)
  EndIf

  ProcedureReturn 0
EndProcedure
Procedure.i SSLv2_client_method()
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSLv2_client_method
    ProcedureReturn ____SSL_LibSSL\SSLv2_client_method()
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.i SSLv3_client_method()
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSLv3_client_method
    ProcedureReturn ____SSL_LibSSL\SSLv3_client_method()
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.i SSLv23_client_method()
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSLv23_client_method
  	ProcedureReturn ____SSL_LibSSL\SSLv23_client_method()
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.i TLSv1_client_method()
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\TLSv1_client_method
    ProcedureReturn ____SSL_LibSSL\TLSv1_client_method()
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.i SSL_new(*ctx)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_new
    ProcedureReturn ____SSL_LibSSL\SSL_new(*ctx)
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure   SSL_free(*ssl)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_free
    ____SSL_LibSSL\SSL_free(*ssl)
  EndIf
EndProcedure
Procedure.l SSL_connect(*ssl)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_connect
    ProcedureReturn ____SSL_LibSSL\SSL_connect(*ssl)
  EndIf

  ProcedureReturn -1
EndProcedure
Procedure.l SSL_shutdown(*ssl)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_shutdown
    ProcedureReturn ____SSL_LibSSL\SSL_shutdown(*ssl)
  EndIf

  ProcedureReturn -1
EndProcedure
Procedure.l SSL_read(*ssl, *buf, len.l)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_read
    ProcedureReturn ____SSL_LibSSL\SSL_read(*ssl, *buf, len)
  EndIf

  ProcedureReturn -1
EndProcedure
Procedure.l SSL_peek(*ssl, *buf, len.l)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_peek
    ProcedureReturn ____SSL_LibSSL\SSL_peek(*ssl, *buf, len)
  EndIf

  ProcedureReturn -1
EndProcedure
Procedure.l SSL_write(*ssl, *buf, len.l)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_write
    ProcedureReturn ____SSL_LibSSL\SSL_write(*ssl, *buf, len)
  EndIf

  ProcedureReturn -1
EndProcedure
Procedure.l SSL_pending(*ssl)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_pending
    ProcedureReturn ____SSL_LibSSL\SSL_pending(*ssl)
  EndIf

  ProcedureReturn 0
EndProcedure
Procedure.s SSL_get_version(*ssl)
  Shared ____SSL_LibSSL
  Protected *res

  If ____SSL_LibSSL\SSL_get_version
    *res = ____SSL_LibSSL\SSL_get_version(*ssl)
    If *res
      ProcedureReturn PeekS(*res, -1, #PB_Ascii)
    EndIf
  EndIf

  ProcedureReturn #NULL$
EndProcedure
Procedure.l SSL_get_error(*s, ret_code.l)
  Shared ____SSL_LibSSL

  If ____SSL_LibSSL\SSL_get_error
    ProcedureReturn ____SSL_LibSSL\SSL_get_error(*s, ret_code)
  EndIf

  ProcedureReturn #SSL_ERROR_SSL
EndProcedure
;}

