;    awsqlitedb.pbi
;    Version 0.4 [2013/08/30]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

XIncludeFile "awsqlstatement.pbi"

CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
	XIncludeFile "awdynsqlite3.pbi"
CompilerElse
;{ Imports
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    ImportC #PB_Compiler_Home + "purelibraries/linux/libraries/libpbsqlite3.a"
  CompilerCase #PB_OS_Windows
    ImportC "sqlite3.lib"
  CompilerEndSelect
  sqlite3_libversion()
  sqlite3_backup_init(*pDest, zDestName.p-ascii, *pSource, zSourceName.p-ascii)
  sqlite3_backup_step(*sqlite3_backup, nPage)
  sqlite3_backup_finish(*sqlite3_backup)
  sqlite3_errcode(*db)
EndImport
;}
CompilerEndIf
;{ Macros
CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
	Macro ____AWPB_OpenDatabase(DataBase, DatabaseName, User, Password, Plugin)
		____AWPB_DynSQLite_OpenDatabase(DatabaseName, User, Password)
	EndMacro
	Macro ____AWPB_CloseDatabase(DataBase)
		____AWPB_DynSQLite_CloseDatabase(DataBase)
	EndMacro
	Macro ____AWPB_IsDatabase(DataBase)
		____AWPB_DynSQLite_IsDatabase(DataBase)
	EndMacro
	Macro ____AWPB_DatabaseQuery(DataBase, Request)
		____AWPB_DynSQLite_DatabaseQuery(DataBase, Request)
	EndMacro
	Macro ____AWPB_FinishDatabaseQuery(DataBase)
		____AWPB_DynSQLite_FinishDatabaseQuery(DataBase)
	EndMacro
	Macro ____AWPB_DatabaseUpdate(DataBase, Request)
		____AWPB_DynSQLite_DatabaseUpdate(DataBase, Request)
	EndMacro
	Macro ____AWPB_DatabaseError(Database)
		____AWPB_DynSQLite_DatabaseError(Database)
	EndMacro
	Macro ____AWPB_DatabaseColumns(Database)
		____AWPB_DynSQLite_DatabaseColumns(Database)
	EndMacro
	Macro ____AWPB_DatabaseColumnName(Database, Column)
		____AWPB_DynSQLite_DatabaseColumnName(Database, Column)
	EndMacro
	Macro ____AWPB_DatabaseColumnType(Database, Column)
		____AWPB_DynSQLite_DatabaseColumnType(Database, Column)
	EndMacro
	Macro ____AWPB_NextDatabaseRow(Database)
		____AWPB_DynSQLite_NextDatabaseRow(Database)
	EndMacro
	Macro ____AWPB_GetDatabaseDouble(Database, Column)
		____AWPB_DynSQLite_GetDatabaseDouble(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseFloat(Database, Column)
		____AWPB_DynSQLite_GetDatabaseFloat(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseLong(Database, Column)
		____AWPB_DynSQLite_GetDatabaseLong(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseQuad(Database, Column)
		____AWPB_DynSQLite_GetDatabaseQuad(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseString(Database, Column)
		____AWPB_DynSQLite_GetDatabaseString(Database, Column)
	EndMacro
CompilerElse
	Macro ____AWPB_OpenDatabase(DataBase, DatabaseName, User, Password, Plugin)
		OpenDatabase(DataBase, DatabaseName, User, Password, Plugin)
	EndMacro
	Macro ____AWPB_CloseDatabase(DataBase)
		CloseDatabase(DataBase)
	EndMacro
	Macro ____AWPB_IsDatabase(DataBase)
		IsDatabase(DataBase)
	EndMacro
	Macro ____AWPB_DatabaseQuery(DataBase, Request)
		DatabaseQuery(DataBase, Request)
	EndMacro
	Macro ____AWPB_FinishDatabaseQuery(DataBase)
		FinishDatabaseQuery(DataBase)
	EndMacro
	Macro ____AWPB_DatabaseUpdate(DataBase, Request)
		DatabaseUpdate(DataBase, Request)
	EndMacro
	Macro ____AWPB_DatabaseError(Database)
		DatabaseError()
	EndMacro
	Macro ____AWPB_DatabaseColumns(Database)
		DatabaseColumns(Database)
	EndMacro
	Macro ____AWPB_DatabaseColumnName(Database, Column)
		DatabaseColumnName(Database, Column)
	EndMacro
	Macro ____AWPB_DatabaseColumnType(Database, Column)
		DatabaseColumnType(Database, Column)
	EndMacro
	Macro ____AWPB_NextDatabaseRow(Database)
		NextDatabaseRow(Database)
	EndMacro
	Macro ____AWPB_GetDatabaseDouble(Database, Column)
		GetDatabaseDouble(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseFloat(Database, Column)
		GetDatabaseFloat(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseLong(Database, Column)
		GetDatabaseLong(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseQuad(Database, Column)
		GetDatabaseQuad(Database, Column)
	EndMacro
	Macro ____AWPB_GetDatabaseString(Database, Column)
		GetDatabaseString(Database, Column)
	EndMacro
CompilerEndIf
;}
;{ SQLiteDB-Object
Interface AWPB_SQLiteDB
  Destroy             ()
  Query.b             (sqlcmd.s)
  Update.b            (sqlcmd.s)
  BeginTransaction.b  ()
  EndTransaction.b    ()
  CancelTransaction.b ()
  BeginBatch.b        ()
  Batch.b             (sqlcmd.s)
  EndBatch.b          (save.b)
  TableExists.b       (tablename.s)
  OpenDB.b            (filename.s, user.s, pass.s)
  OpenMemoryDB.b      ()
  CloseDB             ()
  Handle.i            ()
  GetString.s         (Column.i)
  GetQuad.q           (Column.i)
  GetLong.i           (Column.i)
  GetFloat.f          (Column.i)
  GetDouble.d         (Column.i)
  NextRow.b           ()
  ColumnName.s        (Column.i)
  ColumnType.i        (Column.i)
  Columns.i           ()
  DatabaseError.s     ()
  FinishQuery         ()
  PrepareStatement.i  (sqlcmd.s)
  IsReady.b           ()
  SaveMemoryDB.i			(filename.s)
  LoadMemoryDB.i			(filename.s)
EndInterface
Structure ____AWPB_SQLiteDB
  *vt.AWPB_SQLiteDB

  FileName.s
  Handle.i
  BatchActive.b
  TransactionActive.b
EndStructure
Procedure.i AWPB_CreateSQLiteDBObj()
  Protected *this.____AWPB_SQLiteDB

  *this = AllocateMemory(SizeOf(____AWPB_SQLiteDB))
  If *this
    *this\vt                = ?____AWPB_SQLiteDB_VT
    *this\Handle            = #Null
    *this\TransactionActive = #False
    *this\BatchActive       = #False
    *this\FileName          = ""

    ProcedureReturn *this
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.b ____AWPB_SQLiteDB_Query(*this.____AWPB_SQLiteDB, sqlcmd.s)
	If ____AWPB_IsDatabase(*this\Handle)
		If ____AWPB_DatabaseQuery(*this\Handle, sqlcmd)
			ProcedureReturn #True
		EndIf
	EndIf
	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_SQLiteDB_Update(*this.____AWPB_SQLiteDB, sqlcmd.s)
  If ____AWPB_IsDatabase(*this\Handle)
		If ____AWPB_DatabaseUpdate(*this\Handle, sqlcmd)
			ProcedureReturn #True
		EndIf
	EndIf
	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_SQLiteDB_BeginTransaction(*this.____AWPB_SQLiteDB)
  *this\TransactionActive = ____AWPB_SQLiteDB_Update(*this, "BEGIN TRANSACTION")
  ProcedureReturn *this\TransactionActive
EndProcedure
Procedure.b ____AWPB_SQLiteDB_EndTransaction(*this.____AWPB_SQLiteDB)
  If *this\TransactionActive
    *this\TransactionActive = #False
    ProcedureReturn ____AWPB_SQLiteDB_Update(*this, "COMMIT TRANSACTION")
  EndIf

  ProcedureReturn #True
EndProcedure
Procedure.b ____AWPB_SQLiteDB_CancelTransaction(*this.____AWPB_SQLiteDB)
  If *this\TransactionActive
    *this\TransactionActive = #False
    ProcedureReturn ____AWPB_SQLiteDB_Update(*this, "ROLLBACK TRANSACTION")
  EndIf

  ProcedureReturn #True
EndProcedure
Procedure.b ____AWPB_SQLiteDB_BeginBatch(*this.____AWPB_SQLiteDB)
	*this\BatchActive = ____AWPB_SQLiteDB_BeginTransaction(*this)
	If Not *this\BatchActive
		MessageRequester("SQLite-Error", ____AWPB_DatabaseError(*this\Handle))
	EndIf

	ProcedureReturn *this\BatchActive
EndProcedure
Procedure.b ____AWPB_SQLiteDB_Batch(*this.____AWPB_SQLiteDB, sqlcmd.s)
  If Not *this\BatchActive : ProcedureReturn #False : EndIf
  If Not ____AWPB_SQLiteDB_Update(*this, sqlcmd)
    MessageRequester("SQLite-Error", ____AWPB_DatabaseError(*this\Handle))
    ProcedureReturn #False
  EndIf

	ProcedureReturn #True
EndProcedure
Procedure.b ____AWPB_SQLiteDB_EndBatch(*this.____AWPB_SQLiteDB, save.b)
  Protected res.b

  res = #True
  If *this\BatchActive
    *this\BatchActive = #False

		If save
			If Not ____AWPB_SQLiteDB_EndTransaction(*this)
			  MessageRequester("SQLite-Error", ____AWPB_DatabaseError(*this\Handle))
			  res = #False
			EndIf
		Else
			If Not ____AWPB_SQLiteDB_CancelTransaction(*this)
				MessageRequester("SQLite-Error", ____AWPB_DatabaseError(*this\Handle))
				res = #False
			EndIf
		EndIf
	EndIf

	ProcedureReturn res
EndProcedure
Procedure.b ____AWPB_SQLiteDB_TableExists(*this.____AWPB_SQLiteDB, tablename.s)
  Protected res.b

	res = #False
	If ____AWPB_SQLiteDB_Query(*this, "SELECT [sql] From sqlite_master WHERE [type] = 'table' And LOWER(name) = '" + LCase(TableName) + "' ")
	  If ____AWPB_NextDatabaseRow(*this\Handle)
			res = #True
		EndIf
		____AWPB_FinishDatabaseQuery(*this\Handle)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure   ____AWPB_SQLiteDB_CloseDB(*this.____AWPB_SQLiteDB)
	If ____AWPB_IsDatabase(*this\Handle)
    If *this\BatchActive       : ____AWPB_SQLiteDB_EndBatch(*this, #False)  : EndIf
    If *this\TransactionActive : ____AWPB_SQLiteDB_CancelTransaction(*this) : EndIf
		____AWPB_CloseDatabase(*this\Handle)
	EndIf
	*this\Handle   					= #Null
	*this\FileName 					= ""
	*this\BatchActive 			= #False
	*this\TransactionActive = #False
EndProcedure
Procedure.b ____AWPB_SQLiteDB_OpenDB(*this.____AWPB_SQLiteDB, filename.s, user.s, pass.s)
	Protected f.i

	____AWPB_SQLiteDB_CloseDB(*this)

	*this\FileName = filename
	If filename <> ""
		Select FileSize(filename)
			Case -1:
				f = CreateFile(#PB_Any, filename)
				If IsFile(f)
					CloseFile(f)
				Else
					ProcedureReturn #False
				EndIf
			Case -2:
				ProcedureReturn #False
		EndSelect
	Else
		ProcedureReturn #False
	EndIf

	*this\Handle = ____AWPB_OpenDatabase(#PB_Any, filename, user, pass, #PB_Database_SQLite)
	If ____AWPB_IsDatabase(*this\Handle)
	  ProcedureReturn #True
	EndIf

	ProcedureReturn #False
EndProcedure
Procedure.b ____AWPB_SQLiteDB_OpenMemoryDB(*this.____AWPB_SQLiteDB)
	____AWPB_SQLiteDB_CloseDB(*this)

	*this\FileName = ":memory:"
	*this\Handle   = ____AWPB_OpenDatabase(#PB_Any, *this\FileName, "", "", #PB_Database_SQLite)
	If ____AWPB_IsDatabase(*this\Handle)
	  ProcedureReturn #True
	EndIf

	ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_SQLiteDB_Destroy(*this.____AWPB_SQLiteDB)
  ____AWPB_SQLiteDB_CloseDB(*this)

  FreeMemory(*this)
  ProcedureReturn #Null
EndProcedure
Procedure.i ____AWPB_SQLiteDB_Handle(*this.____AWPB_SQLiteDB)
  ProcedureReturn *this\Handle
EndProcedure
Procedure.s ____AWPB_SQLiteDB_GetString(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_GetDatabaseString(*this\Handle, Column)
EndProcedure
Procedure.q ____AWPB_SQLiteDB_GetQuad(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_GetDatabaseQuad(*this\Handle, Column)
EndProcedure
Procedure.i ____AWPB_SQLiteDB_GetLong(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_GetDatabaseLong(*this\Handle, Column)
EndProcedure
Procedure.f ____AWPB_SQLiteDB_GetFloat(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_GetDatabaseFloat(*this\Handle, Column)
EndProcedure
Procedure.d ____AWPB_SQLiteDB_GetDouble(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_GetDatabaseDouble(*this\Handle, Column)
EndProcedure
Procedure.b ____AWPB_SQLiteDB_NextRow(*this.____AWPB_SQLiteDB)
	If ____AWPB_NextDatabaseRow(*this\Handle)
		ProcedureReturn #True
	EndIf
	ProcedureReturn #False
EndProcedure
Procedure.s ____AWPB_SQLiteDB_ColumnName(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_DatabaseColumnName(*this\Handle, Column)
EndProcedure
Procedure.i ____AWPB_SQLiteDB_ColumnType(*this.____AWPB_SQLiteDB, Column.i)
  ProcedureReturn ____AWPB_DatabaseColumnType(*this\Handle, Column)
EndProcedure
Procedure.i ____AWPB_SQLiteDB_Columns(*this.____AWPB_SQLiteDB)
  ProcedureReturn ____AWPB_DatabaseColumns(*this\Handle)
EndProcedure
Procedure.s ____AWPB_SQLiteDB_DatabaseError(*this.____AWPB_SQLiteDB)
  ProcedureReturn ____AWPB_DatabaseError(*this\Handle)
EndProcedure
Procedure   ____AWPB_SQLiteDB_FinishQuery(*this.____AWPB_SQLiteDB)
  ProcedureReturn ____AWPB_FinishDatabaseQuery(*this\Handle)
EndProcedure
Procedure.i ____AWPB_SQLiteDB_PrepareStatement(*this.____AWPB_SQLiteDB, sqlcmd.s)
  Protected *stat.AWPB_SQLStatement

  *stat = AWPB_CreateSQLStatementObj()
  If *stat
    *stat\SetSQL(sqlcmd)
  EndIf

  ProcedureReturn *stat
EndProcedure
Procedure.b ____AWPB_SQLiteDB_IsReady(*this.____AWPB_SQLiteDB)
  If ____AWPB_IsDatabase(*this\Handle)
    ProcedureReturn #True
  EndIf

  ProcedureReturn #False
EndProcedure
Procedure.i ____AWPB_SQLiteDB_SaveMemoryDB(*this.____AWPB_SQLiteDB, filename.s)
	Protected f, db, *pbackup, rc.i
	CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
		Shared ____SQLiteDyn_lib
		Protected *db1.____SQLiteDyn_Handle, *db2.____SQLiteDyn_Handle
	CompilerEndIf

	If Not ____AWPB_IsDatabase(*this\Handle)
		ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	If filename <> ""
		If FileSize(filename) >= -1
			f = CreateFile(#PB_Any, filename)
			If IsFile(f)
				CloseFile(f)
			Else
				ProcedureReturn 1 ; SQLITE_ERROR
			EndIf
		EndIf
	Else
		ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	db = ____AWPB_OpenDatabase(#PB_Any, filename, "", "", #PB_Database_SQLite)
	If Not ____AWPB_IsDatabase(db)
	  ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
		*db1 = db
		*db2 = *this\Handle
		*pbackup = ____SQLiteDyn_lib\SQLite3_Backup_Init(*db1\db, "main", *db2\db, "main")
		If *pbackup
			____SQLiteDyn_lib\SQLite3_Backup_Step(*pbackup, -1)
			____SQLiteDyn_lib\SQLite3_Backup_Finish(*pbackup)
	  EndIf
	  rc = ____SQLiteDyn_lib\SQLite3_ErrCode(*db1\db)
	CompilerElse
		*pbackup = sqlite3_backup_init(DatabaseID(db), "main", DatabaseID(*this\Handle), "main")
		If *pbackup
			sqlite3_backup_step(*pbackup, -1)
			sqlite3_backup_finish(*pbackup)
	  EndIf
	  rc = sqlite3_errcode(DatabaseID(db))
	CompilerEndIf

  ____AWPB_CloseDatabase(db)

  ProcedureReturn rc
EndProcedure
Procedure.i ____AWPB_SQLiteDB_LoadMemoryDB(*this.____AWPB_SQLiteDB, filename.s)
	Protected f, db, *pbackup, rc.i
	CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
		Shared ____SQLiteDyn_lib
		Protected *db1.____SQLiteDyn_Handle, *db2.____SQLiteDyn_Handle
	CompilerEndIf

	If Not ____AWPB_SQLiteDB_OpenMemoryDB(*this)
		ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	If filename <> ""
		If FileSize(filename) >= 0
			f = ReadFile(#PB_Any, filename)
			If IsFile(f)
				CloseFile(f)
			Else
				ProcedureReturn 1 ; SQLITE_ERROR
			EndIf
		EndIf
	Else
		ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	db = ____AWPB_OpenDatabase(#PB_Any, filename, "", "", #PB_Database_SQLite)
	If Not ____AWPB_IsDatabase(db)
	  ProcedureReturn 1 ; SQLITE_ERROR
	EndIf

	CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
		*db1 = *this\Handle
		*db2 = db
		*pbackup = ____SQLiteDyn_lib\SQLite3_Backup_Init(*db1\db, "main", *db2\db, "main")
		If *pbackup
			____SQLiteDyn_lib\SQLite3_Backup_Step(*pbackup, -1)
			____SQLiteDyn_lib\SQLite3_Backup_Finish(*pbackup)
	  EndIf
	  rc = ____SQLiteDyn_lib\SQLite3_ErrCode(*db2\db)
	CompilerElse
		*pbackup = sqlite3_backup_init(DatabaseID(*this\Handle), "main", DatabaseID(db), "main")
		If *pbackup
			sqlite3_backup_step(*pbackup, -1)
			sqlite3_backup_finish(*pbackup)
	  EndIf
	  rc = sqlite3_errcode(DatabaseID(db))
	CompilerEndIf

  ____AWPB_CloseDatabase(db)

  ProcedureReturn rc
EndProcedure

DataSection ;{
____AWPB_SQLiteDB_VT:
  Data.i @____AWPB_SQLiteDB_Destroy()
  Data.i @____AWPB_SQLiteDB_Query()
  Data.i @____AWPB_SQLiteDB_Update()
  Data.i @____AWPB_SQLiteDB_BeginTransaction()
  Data.i @____AWPB_SQLiteDB_EndTransaction()
  Data.i @____AWPB_SQLiteDB_CancelTransaction()
  Data.i @____AWPB_SQLiteDB_BeginBatch()
  Data.i @____AWPB_SQLiteDB_Batch()
  Data.i @____AWPB_SQLiteDB_EndBatch()
  Data.i @____AWPB_SQLiteDB_TableExists()
  Data.i @____AWPB_SQLiteDB_OpenDB()
  Data.i @____AWPB_SQLiteDB_OpenMemoryDB()
  Data.i @____AWPB_SQLiteDB_CloseDB()
  Data.i @____AWPB_SQLiteDB_Handle()
  Data.i @____AWPB_SQLiteDB_GetString()
  Data.i @____AWPB_SQLiteDB_GetQuad()
  Data.i @____AWPB_SQLiteDB_GetLong()
  Data.i @____AWPB_SQLiteDB_GetFloat()
  Data.i @____AWPB_SQLiteDB_GetDouble()
  Data.i @____AWPB_SQLiteDB_NextRow()
  Data.i @____AWPB_SQLiteDB_ColumnName()
  Data.i @____AWPB_SQLiteDB_ColumnType()
  Data.i @____AWPB_SQLiteDB_Columns()
  Data.i @____AWPB_SQLiteDB_DatabaseError()
  Data.i @____AWPB_SQLiteDB_FinishQuery()
  Data.i @____AWPB_SQLiteDB_PrepareStatement()
  Data.i @____AWPB_SQLiteDB_IsReady()
  Data.i @____AWPB_SQLiteDB_SaveMemoryDB()
  Data.i @____AWPB_SQLiteDB_LoadMemoryDB()
EndDataSection ;}
;}
;{ Global Functions
Procedure.s AWPB_SQLiteLibVersion()
  Protected v.s

	CompilerIf Defined(Enable_DynSQLite3Lib, #PB_Constant)
		Shared ____SQLiteDyn_lib

		v = PeekS(____SQLiteDyn_lib\SQLite3_LibVersion(), #PB_Any, #PB_Ascii)
	CompilerElse
		v = PeekS(sqlite3_libversion(), #PB_Any, #PB_Ascii)
	CompilerEndIf

  ProcedureReturn v
EndProcedure
;}

