;    awwebview.pbi
;    Version 0.3 [2013/03/30]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

CompilerIf #PB_Compiler_OS = #PB_OS_Linux
  ;{ WebKit-Imports
	ImportC "-lwebkitgtk-1.0"
		webkit_web_view_new()
	  webkit_web_view_load_uri(*webview, uri.p-ascii)
	  webkit_web_frame_get_uri(*frame)
	  webkit_web_view_get_load_status(*webview)
	  webkit_web_view_load_string(*webview, content.p-ascii, mime_type.p-ascii, encoding.p-ascii, base_uri.p-ascii)
	  webkit_web_view_get_title(*webview)
	  webkit_download_get_uri(*download)
	  webkit_web_policy_decision_ignore(*decision)
	  webkit_web_policy_decision_download(*decision)
	  webkit_web_policy_decision_use(*decision)
	  webkit_network_request_get_uri(*request)
	  webkit_web_view_go_back(*web_view)
	  webkit_web_view_go_forward(*web_view)
	  webkit_web_view_stop_loading(*web_view)
    webkit_web_navigation_action_get_original_uri(*NavigationAction)
	EndImport

  Enumeration
    #____AWPB_WEBKIT_NAVIGATION_ACCEPT
    #____AWPB_WEBKIT_NAVIGATION_IGNORE
    #____AWPB_WEBKIT_NAVIGATION_DOWNLOAD
  EndEnumeration
  ;}
  ;{ support functions
  Procedure   ____AWPB_WebKit_GTKSignalConnect(*Widget, Signal.s, *Function, *user_data)
    CompilerIf #PB_Compiler_Unicode
      Protected *SignalASCII, SignalLen.i

      SignalLen = Len(Signal)
      *SignalASCII = AllocateMemory(SignalLen + 2)
      If *SignalASCII
        PokeS(*SignalASCII, Signal, SignalLen, #PB_Ascii)
        CompilerIf #GTK_MAJOR_VERSION = 1
          gtk_signal_connect_(*Widget, *SignalASCII, *Function, *user_data)
        CompilerElse
          g_signal_connect_data_(*Widget, *SignalASCII, *Function, *user_data, 0, 0)
        CompilerEndIf
        FreeMemory(*SignalASCII)
      EndIf
    CompilerElse
      CompilerIf #GTK_MAJOR_VERSION = 1
        gtk_signal_connect_(*Widget, @Signal, *Function, *user_data)
      CompilerElse
        g_signal_connect_data_(*Widget, @Signal, *Function, *user_data, 0, 0)
      CompilerEndIf
    CompilerEndIf
  EndProcedure
  ;}
  ;{ Callback Prototypes
	Prototype   ____AWPB_WebView_CB_OnHoveringOverLink(title.s, uri.s)
	Prototype   ____AWPB_WebView_CB_OnLoadProgressChanged(progress.l)
	Prototype.l ____AWPB_WebView_CB_OnNavigationRequested(uri.s)
	Prototype   ____AWPB_WebView_CB_OnPopulatePopup(*menu.GtkMenu)
	Prototype   ____AWPB_WebView_CB_OnStatusBarTextChanged(arg1.s)
	Prototype   ____AWPB_WebView_CB_OnTitleChanged(title.s)
  ;}
  ;{ WebKit-Object
	Interface AWPB_WebView
    Destroy                           ()
    LoadURI                           (URI.s)
    LoadFile                          (FullFileName.s)
    LoadString                        (Content.s, Encoding.s = #NULL$, MimeType.s = #NULL$, BaseURI.s = "")
    Clear                             ()
    Hide                              (State)
    Disable                           (State)
    GadgetHeight.i                    ()
    GadgetWidth.i                     ()
    GadgetX.i                         ()
    GadgetY.i                         ()
    ResizeGadget                      (x, y, Width, Height)
    Back                              ()
    Forward                           ()
    Stop                              ()
    OnHoveringOverLink                (*callback.____AWPB_WebView_CB_OnHoveringOverLink)
    OnLoadProgressChanged             (*callback.____AWPB_WebView_CB_OnLoadProgressChanged)
    OnNavigationRequested             (*callback.____AWPB_WebView_CB_OnNavigationRequested)
    OnPopulatePopup                   (*callback.____AWPB_WebView_CB_OnPopulatePopup)
    OnStatusBarTextChanged            (*callback.____AWPB_WebView_CB_OnStatusBarTextChanged)
    OnTitleChanged                    (*callback.____AWPB_WebView_CB_OnTitleChanged)

	EndInterface
	Structure ____AWPB_WebView
    *vt.AWPB_WebView
    ContainerID.i
    *WebView
    *Scroller

    *OnHoveringOverLink.____AWPB_WebView_CB_OnHoveringOverLink
    *OnLoadProgressChanged.____AWPB_WebView_CB_OnLoadProgressChanged
    *OnNavigationRequested.____AWPB_WebView_CB_OnNavigationRequested
    *OnPopulatePopup.____AWPB_WebView_CB_OnPopulatePopup
    *OnStatusBarTextChanged.____AWPB_WebView_CB_OnStatusBarTextChanged
    *OnTitleChanged.____AWPB_WebView_CB_OnTitleChanged

    InitialPageLoaded.b
  EndStructure
  ;{ Constants
  #AWPB_WEBKIT_NAVIGATION_ACCEPT   = #____AWPB_WEBKIT_NAVIGATION_ACCEPT
  #AWPB_WEBKIT_NAVIGATION_IGNORE   = #____AWPB_WEBKIT_NAVIGATION_IGNORE
  #AWPB_WEBKIT_NAVIGATION_DOWNLOAD = #____AWPB_WEBKIT_NAVIGATION_DOWNLOAD
  ;}
  ;{ Event Callbacks
  ProcedureCDLL   ____AWPB_WebView_OnHoveringOverLinkCB(*webView, *title, *uri, *gdg.____AWPB_WebView)
    Protected title.s, uri.s

    If *gdg\OnHoveringOverLink
      If *title : title = PeekS(*title, -1, #PB_Ascii) : Else : title = "" : EndIf
      If *uri   : uri   = PeekS(*uri,   -1, #PB_Ascii) : Else : uri   = "" : EndIf

      *gdg\OnHoveringOverLink(title, uri)
    EndIf
  EndProcedure
  ProcedureCDLL   ____AWPB_WebView_OnLoadProgressChangedCB(*WebView, progress.l, *gdg.____AWPB_WebView)
    If *gdg\OnLoadProgressChanged
      *gdg\OnLoadProgressChanged(progress)
    EndIf
  EndProcedure
  ProcedureCDLL.l ____AWPB_WebView_OnNavigationRequestedCB(*WebView, *frame, *request, *gdg.____AWPB_WebView)
    Protected *uri, uri.s, action.l

    If *gdg\OnNavigationRequested
      *uri = webkit_network_request_get_uri(*request)
      If *uri
        If *gdg\InitialPageLoaded
          uri    = PeekS(*uri, -1, #PB_Ascii)
          action = *gdg\OnNavigationRequested(uri)

          ProcedureReturn action
        Else
          *gdg\InitialPageLoaded = #True
        EndIf
      EndIf
    EndIf

    ProcedureReturn #____AWPB_WEBKIT_NAVIGATION_ACCEPT
  EndProcedure
  ProcedureCDLL   ____AWPB_WebView_OnPopulatePopupCB(*WebView, *menu.GtkMenu, *gdg.____AWPB_WebView)
    If *gdg\OnPopulatePopup
      *gdg\OnPopulatePopup(*menu)
    EndIf
  EndProcedure
  ProcedureCDLL   ____AWPB_WebView_OnStatusBarTextChangedCB(*WebKit, *arg1, *gdg.____AWPB_WebView)
    Protected arg1.s

    If *gdg\OnStatusBarTextChanged
      If *arg1
        arg1 = PeekS(*arg1, -1, #PB_Ascii)
        *gdg\OnStatusBarTextChanged(arg1)
      EndIf
    EndIf
  EndProcedure
  ProcedureCDLL   ____AWPB_WebView_OnTitleChangedCB(*WebView, *frame, *title, *gdg.____AWPB_WebView)
    Protected title.s

    If *gdg\OnTitleChanged
      If *title
        title = PeekS(*title, -1, #PB_Ascii)
        *gdg\OnTitleChanged(title)
      EndIf
    EndIf
  EndProcedure
  ;}
  ;{ Member Procedures
  Procedure.i AWPB_WebView(GadgetID, x, y, Width, Height, Flags)
    Protected *this.____AWPB_WebView, res.b

    res   = #False
    *this = AllocateMemory(SizeOf(____AWPB_WebView))
    If *this
      *this\vt   = ?____AWPB_WebView_VT
      If GadgetID = #PB_Any
        *this\ContainerID = ContainerGadget(#PB_Any, x, y, Width, Height, Flags)
        If *this\ContainerID : res = #True : EndIf
      Else
        *this\ContainerID = GadgetID
        If ContainerGadget(GadgetID, x, y, Width, Height, Flags) : res = #True : EndIf
      EndIf
      If res
        CloseGadgetList()

        *this\OnHoveringOverLink     = #Null
        *this\OnLoadProgressChanged  = #Null
        *this\OnNavigationRequested  = #Null
        *this\OnPopulatePopup        = #Null
        *this\OnStatusBarTextChanged = #Null
        *this\OnTitleChanged         = #Null
        *this\InitialPageLoaded      = #False

        *this\Scroller = gtk_scrolled_window_new_(#Null, #Null)
        If *this\Scroller
          gtk_scrolled_window_set_policy_(*this\Scroller, #GTK_POLICY_AUTOMATIC, #GTK_POLICY_AUTOMATIC)
          gtk_widget_set_size_request_(*this\Scroller, GadgetWidth(*this\ContainerID), GadgetHeight(*this\ContainerID))
          *this\WebView  = webkit_web_view_new()
          If *this\WebView
            gtk_container_add_(*this\Scroller, *this\WebView)
            gtk_container_add_(GadgetID(*this\ContainerID), *this\Scroller)

            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "hovering-over-link",      @____AWPB_WebView_OnHoveringOverLinkCB(),     *this)
            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "load-progress-changed",   @____AWPB_WebView_OnLoadProgressChangedCB(),  *this)
            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "navigation-requested",    @____AWPB_WebView_OnNavigationRequestedCB(),  *this)
            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "populate-popup",          @____AWPB_WebView_OnPopulatePopupCB(),        *this)
            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "status-bar-text-changed", @____AWPB_WebView_OnStatusBarTextChangedCB(), *this)
            ____AWPB_WebKit_GTKSignalConnect(*this\WebView, "title-changed",           @____AWPB_WebView_OnTitleChangedCB(),         *this)

            gtk_widget_set_events_(*this\WebView, #GDK_ALL_EVENTS_MASK)

            gtk_widget_show_(*this\Scroller)
            gtk_widget_show_(*this\WebView)

            ProcedureReturn *this
          EndIf
        EndIf
      EndIf
      FreeMemory(*this)
    EndIf

    ProcedureReturn #Null
  EndProcedure
  Procedure.i ____AWPB_WebView_Destroy(*this.____AWPB_WebView)
    If IsGadget(*this\ContainerID)
      FreeGadget(*this\ContainerID)
    EndIf
    FreeMemory(*this)
    ProcedureReturn #Null
  EndProcedure
  Procedure   ____AWPB_WebView_LoadURI(*this.____AWPB_WebView, URI.s)
    If URI <> ""
      *this\InitialPageLoaded = #False
      webkit_web_view_load_uri(*this\WebView, URI)
    EndIf
  EndProcedure
  Procedure   ____AWPB_WebView_LoadFile(*this.____AWPB_WebView, FullFileName.s)
     If FullFileName <> ""
      *this\InitialPageLoaded = #False
      webkit_web_view_load_uri(*this\WebView, "file://" + FullFileName)
    EndIf
  EndProcedure
  Procedure   ____AWPB_WebView_LoadString(*this.____AWPB_WebView, Content.s, MimeType.s, Encoding.s, BaseURI.s)
    webkit_web_view_load_string(*this\WebView, Content, MimeType, Encoding, BaseURI)
  EndProcedure
  Procedure   ____AWPB_WebView_Clear(*this.____AWPB_WebView)
    webkit_web_view_load_string(*this\WebView, "", "text/plain", #NULL$, "")
  EndProcedure
  Procedure   ____AWPB_WebView_Hide(*this.____AWPB_WebView, State)
    HideGadget(*this\ContainerID, State)
  EndProcedure
  Procedure   ____AWPB_WebView_Disable(*this.____AWPB_WebView, State)
    DisableGadget(*this\ContainerID, State)
  EndProcedure
  Procedure.i ____AWPB_WebView_GadgetHeight(*this.____AWPB_WebView)
    ProcedureReturn GadgetHeight(*this\ContainerID)
  EndProcedure
  Procedure.i ____AWPB_WebView_GadgetWidth(*this.____AWPB_WebView)
    ProcedureReturn GadgetWidth(*this\ContainerID)
  EndProcedure
  Procedure.i ____AWPB_WebView_GadgetX(*this.____AWPB_WebView)
    ProcedureReturn GadgetX(*this\ContainerID)
  EndProcedure
  Procedure.i ____AWPB_WebView_GadgetY(*this.____AWPB_WebView)
    ProcedureReturn GadgetY(*this\ContainerID)
  EndProcedure
  Procedure   ____AWPB_WebView_ResizeGadget(*this.____AWPB_WebView, x, y, Width, Height)
    ResizeGadget(*this\ContainerID, x, y, Width, Height)
    gtk_widget_set_size_request_(*this\Scroller, GadgetWidth(*this\ContainerID), GadgetHeight(*this\ContainerID))
  EndProcedure
  Procedure   ____AWPB_WebView_Back(*this.____AWPB_WebView)
    webkit_web_view_go_back(*this\WebView)
  EndProcedure
  Procedure   ____AWPB_WebView_Forward(*this.____AWPB_WebView)
    webkit_web_view_go_forward(*this\WebView)
  EndProcedure
  Procedure   ____AWPB_WebView_Stop(*this.____AWPB_WebView)
    webkit_web_view_stop_loading(*this\WebView)
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnHoveringOverLink(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnHoveringOverLink)
    *this\OnHoveringOverLink = *callback
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnLoadProgressChanged(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnLoadProgressChanged)
    *this\OnLoadProgressChanged = *callback
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnNavigationRequested(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnNavigationRequested)
    *this\OnNavigationRequested = *callback
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnPopulatePopup(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnPopulatePopup)
    *this\OnPopulatePopup = *callback
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnStatusBarTextChanged(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnStatusBarTextChanged)
    *this\OnStatusBarTextChanged = *callback
  EndProcedure
  Procedure   ____AWPB_WebView_Set_OnTitleChanged(*this.____AWPB_WebView, *callback.____AWPB_WebView_CB_OnTitleChanged)
    *this\OnTitleChanged = *callback
  EndProcedure
  ;}

  DataSection ;{ Virtual Function Table
  ____AWPB_WebView_VT:
    Data.i @____AWPB_WebView_Destroy()
    Data.i @____AWPB_WebView_LoadURI()
    Data.i @____AWPB_WebView_LoadFile()
    Data.i @____AWPB_WebView_LoadString()
    Data.i @____AWPB_WebView_Clear()
    Data.i @____AWPB_WebView_Hide()
    Data.i @____AWPB_WebView_Disable()
    Data.i @____AWPB_WebView_GadgetHeight()
    Data.i @____AWPB_WebView_GadgetWidth()
    Data.i @____AWPB_WebView_GadgetX()
    Data.i @____AWPB_WebView_GadgetY()
    Data.i @____AWPB_WebView_ResizeGadget()
    Data.i @____AWPB_WebView_Back()
    Data.i @____AWPB_WebView_Forward()
    Data.i @____AWPB_WebView_Stop()
    Data.i @____AWPB_WebView_Set_OnHoveringOverLink()
    Data.i @____AWPB_WebView_Set_OnLoadProgressChanged()
    Data.i @____AWPB_WebView_Set_OnNavigationRequested()
    Data.i @____AWPB_WebView_Set_OnPopulatePopup()
    Data.i @____AWPB_WebView_Set_OnStatusBarTextChanged()
    Data.i @____AWPB_WebView_Set_OnTitleChanged()

  EndDataSection ;}
  ;}
CompilerEndIf

